/* File: permutations.cpp
 *
 * A program to list off all permutations of a master set.
 */
#include <iostream>
#include <string>
#include "set.h"
#include "vector.h"
#include "console.h"
using namespace std;

Vector<string> permutationsOf(string s);
void listPermutationsOf(string s);

int main() {
	string masterString = "ABCDE";
	/*
	Vector<string> permutations = permutationsOf(masterString);
	foreach (string str in permutations) {
		cout << str << endl;
	}
	*/
	listPermutationsOf(masterString);
	
	return 0;
}

void recListPermsOf(string soFar,
					string remaining) {

	if (remaining == "")
		cout << soFar << endl;
	else {
		for (int i = 0; i < remaining.size(); i++) {
			recListPermsOf(soFar + remaining[i],
				remaining.substr(0,i) +
				remaining.substr(i+1));
		}
	}
}

void listPermutationsOf(string remaining) {
	recListPermsOf("",remaining);
}

Vector<string> permutationsOf(string s) {
	Vector<string> results;
	if (s == "") {
		results.add(s);
	} else {
		for (int i = 0; i < s.length(); i++) {
			char ch = s[i];
			string temp = s.substr(0,i) +
				s.substr(i+1);
			Vector<string> v =
				permutationsOf(temp);
			foreach(string str in v) {
				results.add(ch + str);
			}
		}
	}
	return results;
}













